package com.someluigi.tuc.server.init;

import java.io.IOException;

import com.someluigi.tuc.server.HttpServer;
import com.someluigi.tuc.server.registry.BlitemStack;
import com.someluigi.tuc.server.registry.GameRegistry;
import com.someluigi.tuc.server.registry.Rr;
import com.someluigi.tuc.server.registry.TUCRegistryException;
import com.someluigi.tuc.server.util.SysStr;

public class InitRegistry {
	
	public static void initItems() {
		try {
			Rr.i = new Rr.Rri();
			
			GameRegistry.addItem(Rr.i.stick);
		} catch (TUCRegistryException e) {
			SysStr.stdErr.println("Severe Exception when Initializing Item Registry: TUCRegistryException");
			e.printStackTrace();
			// stop the server
			try {
				HttpServer.stop();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		}
	}
		
	public static void initBlocks() {
		try {
			Rr.b = new Rr.Rrb();
			
			GameRegistry.addItem(Rr.b.woodLog);
			GameRegistry.addItem(Rr.b.woodPlank);
		} catch (TUCRegistryException e) {
			SysStr.stdErr.println("Severe Exception when Initializing Item Registry: TUCRegistryException");
			e.printStackTrace();
			// stop the server
			try {
				HttpServer.stop();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		}
	}
		
	public static void initRecipes() {
		try {
			GameRegistry.addRecipe(new BlitemStack[] { new BlitemStack(Rr.i.stick, 16) }, new Object[] {
					new BlitemStack(Rr.b.woodPlank, 1), new BlitemStack(Rr.b.woodPlank, 1)
					}, 1, 2);
			
			GameRegistry.addRecipe(new BlitemStack[] { new BlitemStack(Rr.b.woodPlank, 4) }, new Object[] {
					new BlitemStack(Rr.b.woodLog, 1)
					}, 1, 1);
		} catch (TUCRegistryException e) {
			SysStr.stdErr.println("Severe Exception when Initializing Recipe Registry: TUCRegistryException");
			e.printStackTrace();
			// stop the server
			try {
				HttpServer.stop();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		}
	}	
	
	
	
	
}
