package com.someluigi.tuc.server.registry;


public class BlitemStack {
	
	public BlitemType type; // a "nullstack"
	
	public Integer blitemID = -1;
	public int metadata = 0;
	public int stackSize = 1;
	
	
	public BlitemStack(ItemResponder item, int quantity) throws TUCRegistryException {
		try {
			this.blitemID = item.getClass().getField("blitemID").getInt(item.getClass());
			this.type = BlitemType.ITEM;
			this.stackSize = quantity;
		} catch (Exception e) {
			e.printStackTrace();
			throw new TUCRegistryException();
		}
	}
	
	public BlitemStack(BlockResponder block, int quantity) throws TUCRegistryException {
		try {
			this.blitemID = block.getClass().getField("blitemID").getInt(block.getClass());
			this.type = BlitemType.BLOCK;
			this.stackSize = quantity;
		} catch (Exception e) {
			e.printStackTrace();
			throw new TUCRegistryException();
		}
	}
	
	/*
	public BlitemStack(ItemResponder item) throws IllegalArgumentException, SecurityException, IllegalAccessException, NoSuchFieldException {
		TODO -
	}
	
	public BlitemStack(BlockResponder block) throws IllegalArgumentException, SecurityException, IllegalAccessException, NoSuchFieldException {
		TODO -
	}
	*/
	
	public BlitemStack(int BlitemID, int quantity) {
		this.blitemID = BlitemID;
		try {
			this.type = GameRegistry.blitems.get(BlitemID).getBlitemType();
		} catch (TUCRegistryException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.stackSize = 0;
	}
	
	public BlitemStack() {
		this.blitemID = null;
	}
	
	@Override
	public String toString() {
		if (this.type.equals(BlitemType.ITEM)) {
			return "[" + this.type.toString() + ": " + ((ItemResponder) GameRegistry.blitems.get(this.blitemID)).getName(this) + " (" + this.blitemID + ") * " + this.stackSize + "]";
		} else if (this.type.equals(BlitemType.BLOCK)) {
			return "[" + this.type.toString() + ": " + ((BlockResponder) GameRegistry.blitems.get(this.blitemID)).returnStackName(this) + " (" + this.blitemID + ") * " + this.stackSize + "]";
		}
		return "[ NullStack ]";
	}
	
	
	
	@Override
	public int hashCode() {
		return 1;
	}
	
	public boolean equals(BlitemStack bs) {
		if (this.type.equals(BlitemType.NULL)) {
			if (bs==null) {
				return true;
			}
			if (bs.type.equals(BlitemType.NULL)) {
				return true;
			}
			return false;
		}
		return true;
	}
	
}
