package com.someluigi.tuc.server.registry;

import com.someluigi.tuc.server.block.BlockRecord;
import com.someluigi.tuc.server.events.BlockBreakCause;
import com.someluigi.tuc.server.player.Player;
import com.someluigi.tuc.server.world.Chunk;

public abstract class BlockResponder extends BlitemResponder {	
	
	public static final BlitemType type = BlitemType.BLOCK;
	
	public boolean isOverPlacable = false;
	// can a block be placed to replace this?
	
	public boolean canBreak(BlockRecord b, Chunk c, Player p, BlockBreakCause cause, BlitemStack tool) {
		return true;
	}
	public boolean canPlace(BlockRecord b, Chunk c, Player p, BlitemStack srcStack) {
		return true;
	}
	// CAN? Pre-Event Methods
	
	public void useBlock(BlockRecord b, Chunk c, Player p, BlitemStack usedItem) {
		return;
	}
	// DO! Event Methods
	
	
	public String returnBlockTexture(BlockRecord b, Chunk c, Player p) {
		return "/res/genericBlock.png";
	}
	
	public String returnStackTexture(BlitemStack b, Chunk c, Player p) {
		return "/res/genericBlock.png";
	}
	
	public String returnBlockName(BlockRecord b, Chunk c, Player p) {
		return "Unnamed";
	}
	
	public String returnStackName(BlitemStack b) {
		return "Unnamed";
	}
	
	
	/*
	@Override
	public String toString() {
		try {
			return "[ Responder "+this.getClass().getSimpleName()+" ("+this.getBlitemID()+") ]";
		} catch (TUCRegistryException e) {
			e.printStackTrace();
			return "[! Responder had TUCRegistryException when toString()ing !]";
		}
	}
	*/
	// Other Methods
	
}
