package com.someluigi.tuc.server.registry;

import com.someluigi.tuc.server.player.FakePlayer;
import com.someluigi.tuc.server.world.Chunk;

public abstract class ItemResponder extends BlitemResponder {
	
	public static final BlitemType type = BlitemType.ITEM;
	
	/*
	 * Returns whether the (fake)player can drop this Item or not.
	 * Default value is true if not overriden.
	 * Use FakePlayer.isFake() to see if the player is fake.
	 */
	public boolean canDrop(FakePlayer p, Chunk c, int x, int y, int z) {
		return true; 
	}
	
	/*
	 * This happens when a (fake)player drops the item.
	 * Returning false will cancel ONLY the spawning of the EntityItem.
	 * This is useful for spawning your own EntityItem.
	 * Use FakePlayer.isFake() to see if the player is fake.
	 */
	public boolean onDrop(FakePlayer p, Chunk c, int x, int y, int z) {
		return true;
	}
	
	/*
	 * Returns the textual name for the BlitemStack (ItemStack) provided.
	 */
	public String getName(BlitemStack is) {
		return "Unnamed";
	}
	
	
	
}
